<template>
	<div :class="classList" ref="stub">
		<slot></slot>
	</div>
</template>

<script lang="ts">
import { Vue, Component, Prop, Emit } from 'vue-property-decorator';

@Component({})
export default class IObserver extends Vue {
  private observer: IntersectionObserver | null = null;

  /**
   * @description Animation from Animate.css
   * @link {https://github.com/daneden/animate.css}
   */
	@Prop({ type: String })
	public readonly animation?: string;

	@Prop({ type: Boolean, default: false })
	public readonly infinite!: boolean;

	@Prop({ type: Number, default: 0.5 })
	private readonly threshold!: number;

	@Emit('enter')
	private onIntersectEnter(): void {}

	@Emit('leave')
	private onIntersectLeave(): void {}


	public get classList(): { animated: boolean; [animationName: string]: boolean; infinite: boolean } | null {
		if (this.animation) {
			return {
				animated: true,
				[this.animation]: true,
				infinite: this.infinite,
			};
		} else {
			return null;
		}
	}

	public mounted(): void {
    this.observer = new IntersectionObserver((entries, observer) => {
      const isIntersecting = entries.some(entry => entry.isIntersecting);
      if(isIntersecting){
        this.onIntersectEnter();
      } else {
        this.onIntersectLeave();
      }
			}, {
				threshold: this.threshold,
      }
    )

    this.observer.observe((this.$refs.stub as Element));
	}
	
	public beforeDestroy(){
		this.observer!.unobserve((this as any).$refs.stub);
	}

  
}
</script>
